/**************************************************************************
 * $Id: error.cpp,v 1.1 1998/10/17 19:05:06 rosen Exp rosen $
 *
 * Revision 1.01 1998/10/03 14:34:15  rosen
 *
 * This file is part of Max data acquisition software
 * Copyright (C) 1998 Christian Rosen
 *
 * Max is free software; you can redistribute it and/or modify it
 * under the terms of the version 2 of GNU General Public License as
 * published by the Free Software Foundation.
 *
 * Max is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 * for more details.
 *
 * You should have received a copy of the GNU General Public License
 * (see the file COPYING) in this directory; if not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 **************************************************************************/
//This routine handles the error events
//Call this function out of device function with the ERROR-KONSTANT and
//the function name as parameters -> and error widget is shown
//It returns 1 for o.k. button and 0 for cnacel button pressed
//this allows the device function to terminate the measurement
//in case of a hardware timeout for example
#include <string.h>
#include <stdio.h>

#include <qstring.h>
#include <qwidget.h>
#include <qmessagebox.h>
/*internal error message, not called by the user device*/
int Ierror(char *error, char * device_name,char *msg) {
  QString message;
  printf("device_name %s",device_name);
  printf("Message %s \n",error);
  message = "The Following Error has occured : \n";
  message += error;
  if (strlen(device_name) > 1) {
    message += "in : \n ";
    message += device_name;
    message += "\n";
    message += msg;
    message += "\n";
  }
  bool ok=TRUE;
  switch ( QMessageBox::warning(0,"ERROR",message,
			   QMessageBox::Ignore | QMessageBox::Default,
			   QMessageBox::Abort  | QMessageBox::Escape )) {
			
  case QMessageBox::Ignore :
    ok =1;
    break;
  case QMessageBox::Abort :
    ok = 0;	
    break;
  }
  return ok;
}

