/**
   Include file GPIB.HPP for the MAX program

   (c) 1998 by C. Rosen, C. Otto, D. Rohloff, M. Dammasch

   last edit: 1998/07/14 by M. Dammasch
**/

#ifndef __GPIB_HPP__
#define __GPIB_HPP__

#define GPIB_OK   1
#define GPIB_ERR  0

#define GPIB_STRMAX   255
#define GPIB_NAMEMAX  80

// initflags for gpib_init()
#define IB_IFC   1
#define IB_REM   2
#define IB_CLEAR 4 

//
// Definition of GPIB_Device structure
//
typedef
  struct {
    int  addr;                   //  Bus-Address of the device
    char name[GPIB_NAMEMAX+1];   //  Name-String of the device (as defined in GPIB.CONF)
    int  stat;                   //  Status of the Device (GPIB_ERR or GPIB_OK)
  }
  GPIB_Device;

//
// function prototypes as defined in GPIB.CPP
//
GPIB_Device  gpib_init ( char *device_name, int initflag );
        int  gpib_clear ( GPIB_Device *device );
        int  gpib_write ( GPIB_Device *device, char *formatstr, ... );
        int  gpib_read ( GPIB_Device *device, char *buffer, unsigned long length );

#endif
