#ifndef __GPIBERR_HPP__
#define __GPIBERR_HPP__


/*
	additional defs of status word bits (missing in gpib_user.h)
*/ 
#ifndef EVENT
  #define EVENT	 (1 << 10)	// A DTAS or DCAS event has occured
#endif
#ifndef SPOLL
  #define SPOLL	 (1 <<  9)	/* The board has been serial polled by the
  controller */
#endif
#ifndef LOK
  #define LOK	 (1 <<  7)	// Lockout state
#endif
#ifndef REM
  #define REM	 (1 <<  6)	// Remote State
#endif
#ifndef DTAS
  #define DTAS	 (1 <<  1)	// Device trigger state
#endif
#ifndef DCAS
  #define DCAS	 (1)		// Device clear state
#endif


/*
  Diese Funktion ist fuer das Errorhandling auf dem Gpib-bus
  verantwortlich - mit variabler Argumentenliste!
*/

void gpib_error ( char *formatstr, ... );


/*
  Vorlaeufer-Version von gpib_error(),
  zwecks backward compatibility erhalten
*/
 
void gpiberr ( char *errmsgstr );

#endif
