/**************************************************************************
 * $Id: utils.hpp,v 1.3 1999/02/21 18:49:06 rosen Exp rosen $
 *
 * Revision 1.18  1998/10/03 14:34:15  rosen
 *
 * This file is part of Max data acquisition software
 * Copyright (C) 1997,98 Christian Rosen
 *
 * Max is free software; you can redistribute it and/or modify it
 * under the terms of the version 2 of GNU General Public License as
 * published by the Free Software Foundation.
 *
 * Max is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 * for more details.
 *
 * You should have received a copy of the GNU General Public License
 * (see the file COPYING) in this directory; if not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 ******************************************************************************/

/*! header file of utils.cpp
 * This is a collection of some small widgets and the SaveWidget
 */
#include "definitions.h"
#include "qtincludes.h"
#include <assert.h>
#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <sys/types.h>
#include <math.h>
#include <string.h>

#ifndef _UTILITY_H_
#define _UTILITY_H_
class Options : public QWidget
{
  Q_OBJECT
public :
  Options(const char *dname=0,int save = 0,int plot = 0);
  QLabel      *label1;
  QPushButton *ok;
  QPushButton *cancel;
  QCheckBox   *cb[3];
signals:
  void SIG_setoptions(int,int);
public slots :
  void cancel_pressed();
  void ok_pressed();
  void checkBoxClicked();
private:
  int index;
  int enable;
  int plot;
};
//this class contains widget to set trigger delay in ms
class DelayWidget : public QWidget
{
  Q_OBJECT
public:
  DelayWidget(QWidget *parent = 0,const char* name=0);
  void Setdelay( uint);           //set delay in QlineEdit
signals:
  void SIG_setdelay(uint); //set new options in infolist
public slots :
  void  okpressed();
  void  cancelpressed();
private:
  QLineEdit   *DelayEdit;
  QLabel      *headline;
  QLabel      *label1;
  QPushButton *ok;
  QPushButton *cancel;
};
//this class contains widget to set trigger delay in ms
class UpdateWidget : public QWidget
{
  Q_OBJECT
public:
  UpdateWidget(QWidget *parent = 0,const char* name=0);
  void Setupdate( uint, uint);           //set delay in QlineEdit
signals:
  void SIG_setupdate(uint, uint); //set new options in infolist
public slots :
  void  okpressed();
  void  cancelpressed();
private:
  QLineEdit   *DelayEdit;
  QLabel      *headline;
  QLineEdit   *DelayEdit2;	
  QLabel      *label1;
  QLabel      *label2;	
  QPushButton *ok;
  QPushButton *cancel;
};

class SaveWidget : public QWidget
{
 Q_OBJECT
public :
  SaveWidget(QWidget *parent=0, const char *name=0);
  ~SaveWidget() {
    delete tab;
  }
  void SetFilename(char *,char *,char *,char *,char *,char *,char *);
  void SetText( QString); //set info text in MultiLineEdit
signals:
  void SIG_save(const char *,const char *,const char *,
		int ,char *,const char *,const char *);
public slots :
  void okpressed();
  void cancelpressed();
  void browseclicked();
  void browseclicked2();
  void browseclicked3();
  void browseclicked4();
protected :
  void PaintEvent( QPaintEvent * );
  void ResizeEvent ( QResizeEvent *);
private :
  QComboBox   *FormatSelector; //selector for image formats
  QMultiLineEdit *ed1;  //text window for info file
  QLineEdit   *editor;  //datafilename
  QLineEdit   *editor2; //array filenmae
  QLineEdit   *editor3; //images filename
  QLineEdit   *editor4; //data directory
  QLineEdit   *editor5; //index for images
  QPushButton *okpb;    //o.k
  QPushButton *cpb;     //cancel
  QPushButton *browse1;
  QPushButton *browse2;
  QPushButton *browse3;
  QPushButton *browse4;
  QLabel      *headline;
  QLabel      *title1;
  QLabel      *title2;
  QLabel      *title3;
  QLabel      *title4;
  QLabel      *title5;
  QLabel      *last_dataFname;
  QLabel      *last_arrayFname;
  QLabel      *last_imFname;
  QLabel      *ComboTitle;
  QLabel      *last_aFname;
  QLabel      *last_iFname;
  QLabel      *last_dFname;
  QTabDialog  *tab;
  char        *filename;
  char        *array_filename;
  char        *image_filename;
  char        *directory;
  char        *l_dataname;
  char        *l_arrayname;
  char        *l_imname;
};
#endif
